unit SampleU;

interface

uses
  {$IFDEF WIN32} Windows, ComCtrls, {$ELSE} WinTypes, WinProcs,{$ENDIF}
  Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  HRCommon, HRLinkC, HReport, HRCtrlsC, StdCtrls, DB, DBTables;

type
  TSampleUf = class(TForm)
    HRPage1: THRPage;
    HRGroup1: THRGroup;
    txCustNo: THRDBText;
    lbCustNo: THRLabel;
    txCompany: THRDBText;
    lbCompany: THRLabel;
    txAddr1: THRDBText;
    lbAddr1: THRLabel;
    txAddr2: THRDBText;
    lbAddr2: THRLabel;
    HyperReport1: THyperReport;
    HRLink1: THRLink;
    HRPageBand1: THRPageBand;
    HRLabel1: THRLabel;
    HRSysData1: THRSysData;
    HRLabel2: THRLabel;
    Customer: TTable;
    CustomerSource: TDataSource;
    procedure HyperReport1NextData(Sender: TObject;
      var isEOF: Boolean);
    procedure HyperReport1BeforeReport(Sender: TObject;
      var PrintReport: Boolean);
    procedure HyperReport1CreatePreview(Sender: TObject);
    procedure HyperReport1CheckPreview(Sender: TObject);
    procedure HyperReport1PreviewFailure(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SampleUf: TSampleUf;

implementation

uses SampleCP;

{$R *.DFM}
var
  PageCount, LineCount: integer;

procedure TSampleUf.HyperReport1BeforeReport(Sender: TObject;
  var PrintReport: Boolean);
begin
  PageCount := 0;
  LineCount := 0;
end;

procedure TSampleUf.HyperReport1NextData(Sender: TObject;
  var isEOF: Boolean);
var
  y: integer;
begin
  y := (LineCount+1) * 100;
  HyperReport1.BandPrintAt(  0, y, HRGroup1);
  HyperReport1.BandPrintAt(300, y, HRGroup1);
  Customer.Next;

  inc(LineCount);
  if (LineCount > 5) then begin
      LineCount := 0;
      Inc(PageCount);
      if (PageCount < 3) then begin
          HyperReport1.PageSkip;
      end else begin
          isEof := True;
      end;
  end;
end;

procedure TSampleUf.HyperReport1CreatePreview(Sender: TObject);
begin
  CustomerPreview := TCustomerPreview.Create(Application);
  with CustomerPreview do
  begin
    WindowState := HyperReport1.WindowState;
    HyperReport := HyperReport1;
    if (HyperReport1.ShowModal) then ShowModal else Show;
  end;
end;

procedure TSampleUf.HyperReport1CheckPreview(Sender: TObject);
begin
  with CustomerPreview do begin
    if (WindowState = wsMinimized) then WindowState := wsNormal;
    BringToFront;
  end;
end;

procedure TSampleUf.HyperReport1PreviewFailure(Sender: TObject);
begin
  CustomerPreview.Close;
end;

end.
